<?php

namespace MaagIT\MaagSupermailer\Helper;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Urs Maag <info@maagit.ch>, maagIT
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @package random_images
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Configuration {
		
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// public methods                                                                                                                                                //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //

	/**
     * get the typoscript configuration 
     *
     * @return array	typoscript configuration
     */
	public function getSettings()	{
		// falls Aufruf aus dem Controller dann über $this->objectManager
		$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Object\\ObjectManager');
		$configurationManager = $objectManager->get('TYPO3\\CMS\\Extbase\\Configuration\\ConfigurationManagerInterface');
		/**
 		* mögliche Werte:
 		* 
 		* const CONFIGURATION_TYPE_FRAMEWORK = 'Framework';
 		* const CONFIGURATION_TYPE_SETTINGS = 'Settings';
 		* const CONFIGURATION_TYPE_FULL_TYPOSCRIPT = 'FullTypoScript';
 		*/
		$frameworkConfiguration = $configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_FRAMEWORK);
		return $this->validateSettings($frameworkConfiguration['settings']);
	}
	
	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// protected methods                                                                                                                                                //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //

	/**
     * validates the typoscript configuration settings
     *
     * @param array		$settings
	 * @return array	validated typoscript configuration
     */
	protected function validateSettings($settings)	{

		return $settings;
	}

}
?>