<?php

namespace MaagIT\MaagSupermailer\Mailer;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Urs Maag <info@maagit.ch>, maagIT
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * Mailer for supermailer
 *
 * @package supermailer
 * @license http://www.gnu.org/licenses/lgpl.html
 * 			GNU Lesser General Public License, version 3 or later
 */
class Mailer {
	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// variables and constants                                                                                                                                       //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //
	
	/**
	 * @var	\MaagIT\MaagSupermailer\Helper\Configuration	$settings
	 */
	 protected $settings;


	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// constructors                                                                                                                                                  //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //




	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// public methods                                                                                                                                                //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //
	
	/**
     * send mail
     *
	 * @param  \MaagIT\MaagSupermailer\Domain\Model\Supermailer	$formData
	 * @param  string											$subject
	 * @return boolean
     */
	public function sendMail(\MaagIT\MaagSupermailer\Domain\Model\Supermailer $formData, $subject) {
		// initialization
		$this->settings = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('MaagIT\\MaagSupermailer\\Helper\\Configuration')->getSettings();
		$mailMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Mail\\MailMessage');
		$fromName = $formData->getFirstname() . ' ' . $formData->getLastname();
		$fromAddress = $formData->getEmail();
		$toName = $this->settings['email']['receiverName'];
		$toAddress = $this->settings['email']['receiverAddress'];

		// set sender, receiver and subject
		$mailMessage->setFrom(array($fromAddress => $fromName));
		$mailMessage->setTo(array($toAddress => $toName));
		$mailMessage->setSubject($subject);
		
		// create body text
		if (!in_array($formData->getSalutation(), array(0, 1))) {
			$body .= \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.salutation', 'MaagSupermailer') . ' ';
			$body .= $formData->getSalutation() == 0 ? \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.salutation.woman', 'MaagSupermailer') . "\n" : \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.salutation.man', 'MaagSupermailer') . "\n";
		}
		if ($formData->getLastname() != '') {
			$body .= \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.lastname', 'MaagSupermailer') . ' ' . $formData->getLastname() . "\n";
		}
		if ($formData->getFirstname() != '') {
			$body .= \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.firstname', 'MaagSupermailer') . ' ' . $formData->getFirstname() . "\n";
		}
		if ($formData->getEmail() != '') {
			$body .= \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('email.email', 'MaagSupermailer') . ' ' . $formData->getEmail() . "\n";
		}
		$mailMessage->setBody($body);
		
		// send mail
		return $mailMessage->send();
	}


	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// protected methods                                                                                                                                             //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //

	
}
