<?php

namespace MaagIT\MaagSupermailer\Validator;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Urs Maag <info@maagit.ch>, maagIT
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * Abstract Validator for supermailer
 *
 * @package supermailer
 * @license http://www.gnu.org/licenses/lgpl.html
 * 			GNU Lesser General Public License, version 3 or later
 */
class AbstractValidator {
	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// variables and constants                                                                                                                                       //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //
	
	/**
	 * errorMessage
	 * 
	 * @var array
	 */
	protected $errorMessages = array();

	/**
	 * emailValidator
	 * 
	 * @var \TYPO3\CMS\Extbase\Validation\Validator\EmailAddressValidator
	 */
	protected $emailValidator;

	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// constructors                                                                                                                                                  //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //

	public function __construct() {
		$this->emailValidator = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Validation\\Validator\\EmailAddressValidator');
	}


	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// public methods                                                                                                                                                //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //
	
	/**
	 * validate
	 *
	 * @param	\MaagIT\MaagSupermailer\Domain\Model\Supermailer $formData
	 * @return	boolean
	 */
	public function validate(\MaagIT\MaagSupermailer\Domain\Model\Supermailer $formData) {
		return true;
	}

	/**
	 * get the error message
	 *
	 * @return	string
	 */
	public function getMessage() {
		// initialization
		$errorMessage = '';
		
		// return empty string, if no errors are found
		if (count($this->errorMessages) == 0)	{
			return '';
		}
		
		// create error message string
		$errorMessage = \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('error', 'MaagSupermailer');
		$errorMessage .= '<ul>';
		foreach ($this->errorMessages as $em) {
			$errorMessage .= '<li>'.$em.'</li>';
		}
		$errorMessage .= '</ul>';

		// return message string
		return $errorMessage;
	}

	
	// ============================================================================================================================================================= //
	//                                                                                                                                                               //
	// protected methods                                                                                                                                             //
	//                                                                                                                                                               //
	// ============================================================================================================================================================= //
	
	/**
	 * add a message text to the error array
	 *
	 * @param	string
	 * @return	void
	 */
	protected function addError($error) {
		$this->errorMessages[] = $error;
	}
	
}
